/////////////////////////////////////////////////////////
// Module		AboutDialog.java
// Version		3.10
// Language		Java
// Author		Scott Riley
// History
// 06/09/00    Release 3.10
// 10/26/99    Initial release
//
// Copyright (C) 1999-2000 Tivoli Systems, and IBM Company  
//
////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class AboutDialog extends Dialog  {
	AboutCanvas aboutCanvas;		// We will paint our logo on this canvas
	
   //  Define an inner class to listen for only one window event
   class MyAdapter extends WindowAdapter implements WindowListener {
      public void WindowClosing (WindowEvent evt){
         dispose();
      }
   }

	// Constructor
	AboutDialog(Frame f) 
	{
		super(f, true);

		setLayout(new BorderLayout());

		// Now Draw the logo
		aboutCanvas = new AboutCanvas();
		add("Center", aboutCanvas);
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
      Button b = new Button("OK");
		buttonPanel.add(b);
		buttonPanel.validate();
		add("South", buttonPanel);
		validate();
		setSize(300, 180);
      //  Listen for events.
      b.addActionListener(new ActionEventHandler());
      WindowListener adapter = new MyAdapter();
      addWindowListener(adapter);
		show();
	}

	// Event handler
	// If the 'OK' button was clicked, dispose() this dialog
   class ActionEventHandler implements ActionListener {
      public void actionPerformed(ActionEvent evt) {
         dispose();
      }
   }

	public void processEvent(AWTEvent evt)  {
      if(evt.getID() == WindowEvent.WINDOW_CLOSING){
			dispose();
      }
   }
}

// The canvas on which we draw the help text
class AboutCanvas extends Canvas
{
	// Constructor
	AboutCanvas()
	{
		setBackground(new Color(255,255,255));
	}

	// Here is where we paint all the stuff on the canvas
	public void paint(Graphics g)
	{
		Dimension d = getSize();
		Color bg = getBackground();
		
		g.setColor(new Color(0,0,255));
		// Draw a nice 3-D box around the canvas
		g.draw3DRect(0,0,d.width-2,d.height-2,true);
		g.draw3DRect(2,2,d.width-5,d.height-5,false);
		
		Font fnt = new Font("Times Roman", Font.BOLD, 15);
		FontMetrics fm = g.getFontMetrics();
		g.setFont(fnt);

		g.setColor(new Color(250, 192, 0));
		String logo = new String("Director SDKFind");
		g.drawString(logo,75,25);

		g.setColor(new Color(255,0,192));
		fnt = new Font("Times Roman", Font.PLAIN, 9);
		fm = g.getFontMetrics();
		g.setFont(fnt);
		String sublogo1 = new String("Copyright (C) 1999-2000");
		g.drawString(sublogo1,90,50);

		String sublogo2 = new String("Tivoli Systems, an IBM Company");
		g.drawString(sublogo2,71,65);

 	}

	// The minimum size for the canvas
	// Should not be using all those constant numbers
	public Dimension getMinimumSize()
	{
		Dimension d = new Dimension(250,150);
		return d;
	}
		
	// Would prefer if the canvas of this size
	public Dimension getPreferredSize()
	{
		Dimension d = new Dimension(250,150);
		return d;
	}
}		
