/******************************************************************************
 * Licensed Materials - Property of IBM                            *
 *                                                                            *
 * PID (5697-TKT)                                                             *
 *                                                                            *
 * (C) Copyright by IBM 2000. All Rights Reserved. *
 *****************************************************************************/
package com.BobCo.postit;

/**
 * This interface defines the constants that need to be shared among
 * the Post It classes.
 */
public interface BCPostItConstants
{
  /** Name of BobCo Post It Notebook server's service node                    */
  public static final String POST_IT_SERVER = "BCPostItNotebook";

  /** Command code issued from console to server to create a new post it note */
  public static final int    CREATE_POST_IT_NOTE_CMD     = 0xB0BC0010;

  /** Command code issued from console to server to remove a post it note     */
  public static final int    REMOVE_POST_IT_NOTE_CMD     = 0xB0BC0011;

  /** Command code issued from handler to server to get post it information   */
  public static final int    RETRIEVE_POST_IT_LIST_CMD   = 0xB0BC0012;

  /** Command code issued from handler to server to get object post it info   */
  public static final int    GET_POST_ITS_FOR_OBJECT_CMD = 0xB0BC0013;

  /** Command code issued from handler to server to get object post it info   */
  public static final int    GET_POST_IT_NOTE_TEXT_CMD   = 0xB0BC0014;

  /** Return codes for command actions                                        */
  public static final int    RC_OKAY                         = 0x0000;
  public static final int    RC_UNSUPPORTED_CMD              = 0x0001;
  public static final int    RC_INVALID_PARAMETER            = 0x0002;
}
