package com.BobCo.FileExplorerJVM;

/**
 * This interface defines the constants that need to be shared among
 * the BobCo file explorer classes.
 */
public interface BobCoFileExplorerJVMConstants {
    /** Name of BobCo File Explorer server's service node */
    public static final String serviceNodeName = "BobCoFileExplorerJVM";
    /** Name of BobCo File Explorer client's addressing suffix */
    public static final String clientAddressSuffix = "::BobCoB";
    /** Command code used for TWGRemoteTaskManager communication */
    public static final int    RTMcommandCode = 12561;

    /** Command code issued to client to request list of local fixed drives */
    public static final int    getClientLocalFixedDrives       = 0xB0BC0001;
    /** Command code issued to client to get contents of a directory */
    public static final int    getClientDirectoryContents      = 0xB0BC0002;
    /** Command code issued from console to server to report clients' drives */
    public static final int    consoleRequestLocalFixedDrives  = 0xB0BC0003;
    /** Command code issued from console to server to request directory contents */
    public static final int    consoleRequestDirectoryContents = 0xB0BC0004;

    public static final int    RETURN_OKAY                      = 0;
    public static final int    RETURN_UNRECOGNIZED_COMMAND_CODE = 1;
    public static final int    RETURN_FIND_FAILED               = 2;
    public static final int    RETURN_UNRECOGNIZED_ACT_ID       = 3;

    /** Read only file attribute */
    public static final int    READONLY  = 0x00000001; // read only attribute
    /** "Hidden" file attribute */
    public static final int    HIDDEN    = 0x00000002; // hidden attribute
    /** "System" file attribute */
    public static final int    SYSTEM    = 0x00000004; // system attribute
    /** Directory attribute */
    public static final int    DIRECTORY = 0x00000010; // directory attribute
    /** Archive file attribute */
    public static final int    ARCHIVE   = 0x00000020; // archive attribute
}
