package com.ibm.sysmgt.sdk.CmdTask;

import java.io.File;
import java.lang.Exception.*;
import java.util.Enumeration;
import java.util.MissingResourceException;
import java.util.Vector;
import com.tivoli.twg.engine.*;
import com.tivoli.twg.libs.*;
import com.tivoli.twg.log.*;
import com.tivoli.twg.util.*;
import  java.io.IOException;
import  java.util.Enumeration;
import  java.io.*;
import  com.tivoli.twg.libs.TWGEnvironment;
import  java.util.Properties;
import com.tivoli.twg.log.TWGRas;


import com.tivoli.twg.libs.TWGEnvironment;

/**
 * TWGEventServer.
 */

public class CmdTaskServer implements TWGTaskServer, RemoteTaskActivationListener
{
   public  static final String SERVICE_NODE_NAME = "CmdTaskServer";
   public  static final String TASK_ID = "CmdTask|CmdTaskServer";
   public  static final String EVENT_LOG_FILENAME  = "TWGEvent.log";
   public  static final String ACTION_LOG_FILENAME = "TWGAction.log";
   public  static final String EVENT_FILTER_FILENAME = "TWGFilter.ini";
   public  static final String ACTION_FILENAME     = "TWGAction.ini";
   public  static final String EVENT_TYPE_FILENAME = "TWGType.ini";
   public  static final String EVENT_SENDER_FILENAME = "TWGSender.ini";
   public  static final String PUBLISH_BY_LOCALE_FILENAME = "TWGPublish.ini";
   public  static final String PUBLISH_BY_KEYWORD_FILENAME = "TWGPubEvnt.ini";
   public  static final String PUBLISH_DETAIL_FILENAME = "TWGPubDetail.ini";
   public  static final String EVENT_PLAN_FILENAME = "TWGEventPlan.ini";
   public  static final String EVENT_CORR_FILENAME = "TWGCorrelator.ini";
   public  static final String EVENT_SYSVAR_FILENAME = "EventSysVar.prop";
   public  static final int    EVENT_CACHE_FILE_SIGNATURE = 0x250DBA5F;
   public  static final String EVENT_CACHE_FILE_NAME      = "EventCache.log";
   public  static final int    EVENT_CACHE_RESERVED_SLOTS = 15;
   public  static final String RESOURCE_BUNDLE_NAME = "com.ibm.sysmgt.sdk.CmdTask";
   private static final String RAS_HEADER = "CmdTaskServer: ";

   public  static final int SERVER_STATE_UNKNOWN      = 0;
   public  static final int SERVER_STATE_INITIALIZING = 1;
   public  static final int SERVER_STATE_READY        = 2;
   public  static final int SERVER_STATE_RUNNING      = 3;
   public  static final int SERVER_STATE_TERMINATING  = 4;
   private static int state = SERVER_STATE_INITIALIZING;

   private static MultiLocaleBundle bundle = null;
   private static CmdTaskServiceNode cmdTaskServiceNode = null;

   private static CmdTaskServer cmdTaskServer = null;

   private static Vect classRefs = new Vect();
   private static String[] classNames = null;
   private static boolean error;
   private Object waitobj = new Object();
   private boolean serverActive = true;
   private static String dataPath = null;
   private static String logPath = null;

   /** Constructor. */
   public CmdTaskServer()
   {
      cmdTaskServer = this;
      //serverActive = true;
      //waitobj = new Object();
      if (TWGRas.isTraceALERTS)
         TWGRas.entry(TWGRas.ALERTS,"CmdTaskServer constructor");


     /* Superclass relies on this constructor to create the task server's service   */
     /* node.  Task activation does not complete until the service node is open.    */
      Exception excp = null;
      String msg;
      try {
         /* Create server task's service node */
         cmdTaskServiceNode = new CmdTaskServiceNode(SERVICE_NODE_NAME);
         if (cmdTaskServiceNode == null)
            throw new ServiceNodeClosedException("ServiceNode.Create failed");
         if (TWGRas.isTraceALERTS) {
            msg = cmdTaskServiceNode.Name() + " service node created";
            TWGRas.debug(TWGRas.ALERTS, msg);
         }
         bundle = MultiLocaleBundle.getSharedBundle(RESOURCE_BUNDLE_NAME);
      }
      catch (ServiceNodeException x)   { excp = x; }
      catch (MissingResourceException x) {excp = x; }

      if (excp != null)
      {
         //error = true;
         TWGRas.debug(TWGRas.EX0,excp.getMessage());
         excp.printStackTrace();
         TWGRas.error(TWGRas.ALERTS, "CmdTaskServer exception: ", excp);
      }
      
      if (TWGRas.isTraceALERTS)
         TWGRas.exit(TWGRas.ALERTS,"CmdTaskServer constructor");
   }

   /**
    * This method is called first so that the server task can perform any
    * initialization prior to run() getting called.  If there are any other
    * threads needed besides the thread that calls run() they should be created
    * here.  Since the thread calling serverActivate() is dedicated to the
    * activation process, it is expected that control will not be returned from
    * this call until server task activation has completed.
    *
    * @return true if server activation completed successfully. or false if it
    *         failed
    */
   public boolean serverActivate(TWGTask task)
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entryExit(TWGRas.ALERTS, "CmdTaskServer.serverActivate");
      return true;
   }

   /** Run, the real main thread. */
   public void run()
   {
      Thread.currentThread().setName("CmdTaskServerMain");

      String  msg;

      /*if (!error)
      {
         // make references to static classes to avoid garbage collection
         for (int i = 0; i < classNames.length; i++)
         {
            try
            {
               // TWGRas.debug(TWGRas.EX0,"Add reference to " + classNames[i]);
               classRefs.addElement(Class.forName(classNames[i]));
            }
            catch (ClassNotFoundException e)
            {
               error = true;
               TWGRas.debug(TWGRas.EX0,e.getMessage());
               e.printStackTrace();
               TWGRas.error(TWGRas.ALERTS, "CmdTaskServerMain: exception!", e);
            }
         }
      }	*/
      
      while (serverActive) {
         synchronized(waitobj) {
            try {
               waitobj.wait();
            } catch (InterruptedException e) {
            }
         }
      }

      String extDir = TWGEnvironment.getExtensionsDirectory() + File.separator;
      String sysDir = TWGEnvironment.getRootDirectory() + File.separator;
   }

      /* Get the list of disabled action handlers from the engine */
      

   /**
    * This method is called when the server needs to deactivate this server
    * task.  The server task should perform any necessary clean up including
    * shutting down any additional threads it may have started and cause the
    * thread running in the run() method to return.
    */
   public void serverDeactivate()
   {
       Exception e = new Exception();
      if (TWGRas.isTraceALERTS)
         TWGRas.debug(TWGRas.EX0, "CmdTaskServer.serverDeactivate : ", e);

      terminate();

      if (TWGRas.isTraceALERTS)
         TWGRas.debug(TWGRas.EX0, "CmdTaskServer.serverDeactivate : ", e);
   }

   /**
    * This method is called when a subtask activation has been received from
    * the console for this task.  The thread calling this method is responsible
    * for perfoming all subtaskActivate() calls, so control should not be kept
    * here for long.  If subtask activation requires waiting for an asynchronous
    * state change or event to occur, then this method should return indicating
    * that the activation is still pending and complete the subtask activation
    * later by calling act.getTask().subtaskActivateComplete().
    *
    * @param  act  the TWGTaskActivation object for the subtask being activated.
    * @return      Use one of the following final values from TWGTask:
    *              <ul>
    *              <li>SUBTASK_ACT_COMPLETE - completed successfully
    *              <li>SUBTASK_ACT_FAILED   - subtask activation failed
    *              <li>SUBTASK_ACT_PENDING  - subtask activation will complete
    *                                         asynchronously
    *              </ul>
    */
   public int subtaskActivate(TWGTaskActivation act)
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entryExit(TWGRas.ALERTS, "CmdTaskServer.subtaskActivate");
      return TWGTask.SUBTASK_ACT_COMPLETE;
   }

   /**
    * This method is called when a subtask deactivation has been received from
    * the console for this task.
    */
   public void subtaskDeactivate(TWGTaskActivation act)
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entryExit(TWGRas.ALERTS, "CmdTaskServer.subtaskDeactivate");
   }

   /**
    * This method is called when a subtask activation has occurred.
    * @param act the TWGRemoteTaskActivation object containing the task activation
    *            information.
    */
   public void taskActivated(TWGRemoteTaskActivation act)
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entryExit( TWGRas.ALERTS, "CmdTaskServer.taskActivated" );
   }

   /**
    * This method is called when a subtask deactivation has occurred.
    * @param act the TWGRemoteTaskActivation object containing the task activation
    *            information.  This is the same object that was passed to the
    *            taskActivated() method.
    */
   public void taskDeactivated(TWGRemoteTaskActivation act)
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entryExit( TWGRas.ALERTS, "CmdTaskServer.taskDeactivated" );
   }

   /**
    * The task server has been deactivated and any clean up required should be
    * done during this method.  After this method is called, the task server's
    * JVM will terminate.
    */
   public void serverDeactivated()
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entry( TWGRas.ALERTS, "CmdTaskServer.serverDeactivated" );

      terminate();

      if (TWGRas.isTraceALERTS)
         TWGRas.exit( TWGRas.ALERTS, "CmdTaskServer.serverDeactivated" );
   }

   private void terminate()
   {
      if (TWGRas.isTraceALERTS)
         TWGRas.entry( TWGRas.ALERTS, "CmdTaskServer.terminate" );

      state = SERVER_STATE_TERMINATING;

      /* remove listeners */
      //TWGEventRouter.removeListener(this);
      TWGRemoteTaskManager.removeActivationListener(SERVICE_NODE_NAME);

      
      if (cmdTaskServiceNode != null)
      {
         try
         {
           cmdTaskServiceNode.Close();
         }
         catch (ServiceNodeException e)
         {
           TWGRas.error(TWGRas.ALERTS, "Service node exception", e);
         }
         // Do not set servicenode to null. Seems to be causing problems with pending server 
         // activities while server is coming down...
         // eventManagerServiceNode = null;
      }

      serverActive = false;
      synchronized (waitobj) {
         waitobj.notifyAll();
      }

      if (TWGOutput.outputEnabled)
         TWGRas.debug(TWGRas.EX0,"CmdTaskServer.terminate: Shutdown complete");
      if (TWGRas.isTraceALERTS)
         TWGRas.exit( TWGRas.ALERTS, "CmdTaskServer.terminate: Shutdown complete");
   }

   public static int getState() { return state; }

   public static MultiLocaleBundle getBundle() { return bundle; }

   public static CmdTaskServiceNode getServiceNode() { return cmdTaskServiceNode; }

   public static long getServerUID()
   {
      try
      {
         byte[] uid = ServiceNode.LocalUniqueID();
         return IntelByteBuffer.ReadLong64(uid, 0);
      }
      catch (ServiceNodeException e)
      {
         if (TWGRas.isTraceALERTS)
            TWGRas.debug(TWGRas.ALERTS, "CmdTaskServer.getServerUID(): exception!", e);
         if (TWGOutput.outputEnabled)
            TWGRas.debug(TWGRas.EX0,"CmdTaskServer.getServerUID(): exception! " + e.getMessage());
         return 0;
      }
   }

   public static String getServerName()
   {
      try
      {
         String name = null;
         name = ServiceNode.LocalSystemName();
         return name;
      }
      catch (ServiceNodeException e)
      {
         if (TWGRas.isTraceALERTS)
            TWGRas.debug(TWGRas.ALERTS, "CmdTaskServer.getServerName(): exception!", e);
         if (TWGOutput.outputEnabled)
            TWGRas.debug(TWGRas.EX0,"CmdTaskServer.getServerName(): exception! " + e.getMessage());
         return null;
      }
   }


   public static String getDataPath() { return dataPath; }

   public static String getLogPath()  { return logPath; }
      
}
