/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * 09N6996
 *
 * (C) Copyright IBM Corp. 1999, 2004 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Enumeration;
import java.util.Vector;
import java.util.Hashtable;

public class FindWords
{
    URL pageToSearch;
    FindFrame myFrame;
    String searchString;
    Vector subStrings = new Vector(5);

    // Constructor
    FindWords(FindFrame mf, String server, String string, boolean isCaseSensitive)
    {
        myFrame = mf;
        searchString = new String(string);

      if(isCaseSensitive) {
         searchString = string;
      }  else {
         searchString = string.toLowerCase();
      }

        // If boolean search, split up the search string into substrings.
        if (myFrame.optionsPanel.isBooleanSearch()) {
            StringTokenizer st = new StringTokenizer(searchString);
            subStrings.ensureCapacity(st.countTokens());
            while (st.hasMoreTokens()) {
                subStrings.addElement((String) st.nextToken());
            }
        } else {
            subStrings.addElement(searchString);
        }
        myFrame.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        myFrame.searchPanel.searchButton.setEnabled(false);
        myFrame.currentPageNumber++;
      System.out.println("FindWords running...");

        if (myFrame.currentPageNumber > myFrame.sdkFind.totalPages) {
            System.out.println("SDKFind: More than"
                            + myFrame.sdkFind.totalPages
                            + "pages have been searched.  So stopping.");
        }

        String contentsOfPage;  // The entire page is stored in this string.
        String contentsOfPageLC;  // The entire page is stored in this string.
        boolean isMatch;
      Vector pages;

      pages = new Vector(800);    //  will hold a sequence of HTML files
      pages.addElement("CIMOverview.html");
      pages.addElement("DMIOverview.html");
      pages.addElement("EventAction.html");
      pages.addElement("e_agent_reg.html");
      pages.addElement("e_win_agent_reg.html");
      pages.addElement("e_browserguitask.html");
      pages.addElement("e_collector.html");
      pages.addElement("e_creat_event.html");
      pages.addElement("e_creat_tbl.html");
      pages.addElement("e_def_filt.html");
      pages.addElement("e_deployment.html");
      pages.addElement("e_dist_cfg.html");
      pages.addElement("e_event_actions.html");
      pages.addElement("e_event_subscriber_cim.html");
      pages.addElement("e_event_subscriber_client.html");
      pages.addElement("e_extensions.html");
      pages.addElement("e_file_source.html");
      pages.addElement("e_filt_assoc.html");
      pages.addElement("e_guitask.html");
      pages.addElement("e_itdsdk_ovrvw.html");
      pages.addElement("e_jagent_ext.html");
      pages.addElement("e_persist_objects.html");
      pages.addElement("e_query_db.html");
      pages.addElement("e_resource_monitor_agent.html");
      pages.addElement("e_resource_monitor_enum_strings.html");
      pages.addElement("e_resource_monitor_thresh_template.html");
      pages.addElement("e_server_prefs.html");
      pages.addElement("e_snapins.html");
      pages.addElement("e_snmp.html");
      pages.addElement("e_snmptraptoevent.html");
      pages.addElement("e_sn_comm.html");
      pages.addElement("e_tasks.html");
      pages.addElement("e_trans.html");
      pages.addElement("e_troubleshooting.html");
      pages.addElement("e_updat_tbl.html");
      pages.addElement("f_begin.html");
      pages.addElement("f_getstart.html");
      pages.addElement("f_changes.html");
      pages.addElement("ITDirindex.html");
      pages.addElement("itdirtop.html");
      pages.addElement("itdirwel.html");
      pages.addElement("MonitorAgentSDK.html");
      pages.addElement("r_db_col_filter.html");
      pages.addElement("r_db_commands.html");
      pages.addElement("r_db_encoding.html");
      pages.addElement("r_db_query_buf.html");
      pages.addElement("r_db_update_ret_codes.html");
      pages.addElement("r_mon_constants.html");
      pages.addElement("r_mon_structs.html");
      pages.addElement("r_task_properties.html");
      pages.addElement("r_TWGSdEvt.html");
      pages.addElement("s_all_overview.html");
      pages.addElement("s_associations_overview.html");
      pages.addElement("s_browser_overview.html");
      pages.addElement("s_communication_overview.html");
      pages.addElement("s_console_overview.html");
      pages.addElement("s_datalinks_overview.html");
      pages.addElement("s_EventHandler_overview.html");
      pages.addElement("s_event_subscriber_overview.html");
      pages.addElement("s_FileExplorer_overview.html");
      pages.addElement("s_file_source_overview.html");
      pages.addElement("s_inventory_overview.html");
      pages.addElement("s_jsubagent_overview.html");
      pages.addElement("s_managedobject_overview.html");
      pages.addElement("s_MonitorAgent_overview.html");
      pages.addElement("s_MonitorAPI_overview.html");
      pages.addElement("s_MonitorLibrary_overview.html");
      pages.addElement("s_monlet_overview.html");
      pages.addElement("s_procman_overview.html");
      pages.addElement("s_RMON_overview.html");
      pages.addElement("s_snapins_overview.html");
      pages.addElement("s_trans_java.html");
      pages.addElement("s_trans_native.html");
      pages.addElement("e_cli.html");
      pages.addElement("e_glossary.html");
      pages.addElement("e_dfrules.html");
      pages.addElement("s_cli_overview.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/procman/api/ExecuteCommandAPI.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/agent/TWGAgentExtension.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/agent/TWGAgentExtensionException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionEndInfo.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionInfo.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionLogManager.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParm.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmDropDown.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmListBox.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmLongSpinner.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmMultiSelList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmStringSpinner.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmText.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmTextArea.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGActionParmTextBox.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGBaseEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGDetail.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventCorrelator.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventDetail.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventHandler.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGEventListenerManager2.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGMessage.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPartialEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublish.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublishCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublishDetail.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublishEventType.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublishException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGPublishTextTemplate.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGUnpublish.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGUnpublishCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/alertmgr/TWGUnpublishEventType.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/console/TWGConsoleColor.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/console/TWGHelpContext.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/console/TWGTaskFrame.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/console/TWGTaskFrameImplementor.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/dmi/MIF_Types.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AbortRestorePersistentObjectException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AbortSavePersistentObjectException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AckPopupEventCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ActDeactUserAccountCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AddRemoveKeyCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AddRemoveMOIDsFromStaticGroupCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AddRemoveTaskToObjectsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AddressEntryFormatException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/AddressEntryShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/CancelPopupEventCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ClientServiceListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/CreateNonNativeAccountCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/CreatePopupEventCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/DeleteNonNativeAccountCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/DeleteTWGUserCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/DistConfigAgentResult.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/DuplicateObjectIDException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/FindFilterByIDCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/FindObjectByAttribCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/GetAddressEntryRecordCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/GetAllAllowedMOIDCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/GetUserAccountInfoCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/InitTWGUserCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/InvalidObjectIDException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ListMOStatusDefsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectFactoryActivateException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectFactoryDeactivateException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectFactoryDiscoverException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectFactoryInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectFactoryUnregisteredClassException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectLifeCycleCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ManagedObjectStateChangeCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/NativeManagedObjectAddObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/NativeManagedObjectGetAllIDs.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/NativeManagedObjectGetByUIDs.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/NativeManagedObjectGetIPCPaths.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/NativeManagedObjectGetSNIDRecords.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/QueryProdLimitPropsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/RemoteMOLifeCycleListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/RemoteMOStateChangeListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/RemoteTaskActivationListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/RemoteTaskActivatorListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/RequestAllUserShadowsCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/ResolveFilterMembersCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/SendPopup.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/SetClearMOStatusCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGActiveConsole.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGActiveConsoleListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGAddressEntryListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGAssociation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGBaseExtension.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGBaseShadowedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGByteArrayInputStream.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGByteArrayOutputStream.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGClassInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGClientServiceListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGClientTaskList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConActiveConsole.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConAssociation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConExtension.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConfigPanelBeans.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConfigProperties.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConfigPropertiesCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConImageSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConLicenses.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObjectSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObjectStatusGroup.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObjectStatusGroup.StatusDefinition.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConManagedObjectStatusSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConObjectException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConObjectListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConObjectUpdateException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConPopupEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConPrivToken.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConRelationship.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConRelationshipSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConsoleAndSubtaskListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConsoleServiceNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConsoleSpecShadowedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConTask.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGContentInfoBeans.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGContentInfoEventHandler.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGContentInfoObjectHandler.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGConUser.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDatabase.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDatabaseConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDatabaseInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDatabaseQuery.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDatabaseTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbChangeQueryCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbCharColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbColumnData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbColumnNotFoundException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbColumnOperators.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbConnection.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbCopyQueryCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbCreateQueryCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDateColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDates.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDatetimeColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDeleteRowsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDelQueryCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDoubleColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbDoubleColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbFindTableByClassnameCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbFindTableReply.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbFloatColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbGetMetaDataCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbGetQueriesCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbGetTablesCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbIntegerColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbIntegerColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbInvalidQueryException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbISOTimeParse.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbLongColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbMetaData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbNoMoreRowException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbNotFoundException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbParameterException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryField.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryNotFoundException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryParms.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryReply.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryResult.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbQueryResults.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbRealColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbRealTableNameNotUniqueException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbReplaceManagedObjCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbReply.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbResultSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbResultSetMetaData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbRow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbRunQueryCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbShortColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbSmallintColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbSQLException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbStoreRow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbStoreRowsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbStringColumnFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbTableParms.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbTableReply.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbTCPIPColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbTokenTableNameNotUniqueException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbUtil.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDbVarcharColumn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDefaultTask.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDeltaShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigAgentUpdate.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigQueryHashcodesCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigQueryHashcodesForObjCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigQueryRecordsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigQueryRecordsForObjCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigRecord.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigRecordChangeListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigRecordDef.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigRecordHashcode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGDistConfigSetRecordsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGExtension.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGExtensionException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGExtensionInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGExtensionTermException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterConstraint.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterConstraints.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterDeleteCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterFactoryParms.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterNotFoundException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterNotifyCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterParms.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterSubscribeCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterSubscriber.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGFilterUnsubscribeCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGGetAllAttributesCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGGetAttributeCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGGetSetDescInterface.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGGetSetInterface.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGImageSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGJobActivation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGLocalManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGLocalTaskClients.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectAccessRequestCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectActionListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectClassEnumCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectDeleteCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectEnumCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectFactoryException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectLifeCycleListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectRestartCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectStateListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectStatusGroup.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectStatusSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGManagedObjectStatusSetConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGNativeAddressEntryShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGNativeManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGNativeManagedObjectConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGNativeManagedObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGObjectDestroyException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGObjectEnumCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGObjectException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectDictionary.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectDictionaryException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectEnumCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectRestoreException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPersistentObjectSaveException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPingCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPopupEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPopupEventHandler.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPrivToken.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGPrivTokenConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGProtectedGetSetInterface.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGQueueBatch.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGQueueElement.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGQueueTimer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRelationship.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRelationshipSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteJobActivation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteJobListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteJobManager.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteSnapInManager.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteTaskActivation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteTaskClients.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGRemoteTaskManager.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSecureRequestListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSecureUnsecureObjectsCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGServerCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGServerCommandHandler.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGServerServiceNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGServerServiceNodeConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSetAttributeCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSetSvcNodePublicCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGShadowedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSnapIn.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSnapInManager.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGStartFullDiscoverCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGStatusCodes.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGSubtask.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTask.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskActivation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskActivationException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskActivationListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskActivator.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskMenuList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGTaskServer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGUpdateRequestCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGUser.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGUserConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGUserPropertiesCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/TWGUserPropertiesCommandException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/UpdateNonNativeAccountPasswordCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/UserNotAuthorizedException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cli/ICliBundle.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/MakeClusterGroupCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/TWGClusterManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/TWGClusterManagedObjectConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/TWGClusterManagedObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/TWGClusterMembershipTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/cluster/TWGClusterMemberTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/TWGEventDescriptor.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/TWGEventSourceDescriptor.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/TWGEventSourceDetail.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/agent/EventProvider.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/agent/SendEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/evtsub/agent/SendEventCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FileAttrs.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FileSource.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FSAgent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FSConsole.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FSServer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FSServerV1.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FSTObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FTConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/filetransfer/FTException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/guilibs/AnimationPanel.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/guilibs/BrowserLauncher.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/guilibs/TWGDynamicHelp.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGAS400HardwareTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGComponentIdTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGDiskTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGIdeAdapterTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGIdeDeviceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGInstalledMemoryTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGInvCollector.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGIpAddressTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGIpxAddressTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGKeyboardTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGLogicalDriveTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGLogicalMemoryTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGManagedObjectTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGMemoryModuleTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGMotherboardTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGNetworkAdapterTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGOperatingSystemTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGParallelPortTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGPartitionTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGPciDeviceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGPhysicalContainerGlobalTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGPointingDeviceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGPrinterTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGProcessorTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGScsiAdapterTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGScsiDeviceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSerialPortTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSnmpMib2Table.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSoftwareTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSystemBiosTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSystemLocationTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSystemResourceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGSystemUserTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGVideoTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/inventory/TWGWindowsNetworkIdTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/BadServiceNodeImplException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ByteArrayInputStr.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ByteArrayOutputStr.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/CmdPacket.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/Command.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/CommandCompleteListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/CommandReceivedListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/CommentedProperties.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/CompUnicodeString.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/DataValue.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/DateTime.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/DoubleSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/DoubleValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/FloatSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/FloatValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/GenericPoller.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/GenericWaiter.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/HashTbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/IntelByteBuffer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/IntKeyTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/IntSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/IntValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/LocalizedStringSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/LongKeyTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/LongSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/LongValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/MergeSort.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/MultiLocaleBundle.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/NoSuchKeyException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ObjectQueue.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/QueueBatch.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/QueueBatch.QueueServer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/QueueElement.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/QueueTimer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ReadWriteMux.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/SendAuthorizationCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeClosedException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeFunctionUnsupportedException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeImpl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeImplFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeInternalCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeLocalImpl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeLocalImplFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeModeException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeRemoteImpl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeRemoteImplFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceNodeRemoteListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ServiceThread.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/SessionHoldCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/SessionReleaseCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ShortKeyTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ShortSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/ShortValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/StringList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/StringSortSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/StringValueSet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGBadAuthCodeException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGBadPasswordException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGBadUserIDException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGBoolean.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGBooleanArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGByte.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGByteArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGDataLink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGDataLinkMultiplexer.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGDate.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGDouble.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGDoubleArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGEnvironment.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGFloat.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGFloatArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGInitParmException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGInteger.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGIntegerArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGIPCClientLink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGIPCSecurity.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGIPCSecurityLogon.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGLinkException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGLinkInitException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGLinkNotSupportedException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGLong.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGLongArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGOpSysEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGShort.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGShortArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGString.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGStringArray.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/TWGTransmitObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/UserIDSecurity.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/libs/Vect.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGLog.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGLogBookmark.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGLogListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGLogMsg.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGLogTracker.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGOutput.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGRas.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGRas.ProcessFileOutputStream.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/log/TWGRasLogger.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonAttributeDataSink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonAttributeMetaDataSink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonAttributeNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonAttributeNodeList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonAttributePath.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonCurrentData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonEnumStrings.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonMOAddressInfoProvider.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonMOAttributeInfoProvider.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonMOStateInfoProvider.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonRecordedData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonRecordingDataSink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonSubSys.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonSubSysCapabilities.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonThreshold.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonThresholdEvent.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/TWGMonThresholdEventSink.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonAPI.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonAttribute.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonAttributeUpdateListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonDoubleThresholdData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonNodeList.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonNodeListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonPath.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonStringThresholdData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monitor/api/TWGMonThreshold.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monlet/Monlet.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monlet/MonletAttributeNode.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monlet/MonletAttrMetaData.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monlet/MonletException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/monlet/MonletInvalidHandleException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSAddObjectCmd.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSAddressEntryShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSAgentCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSClusterInfoTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSGetFullConfigCommand.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSGroupResTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSGroupTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSManagedObjectConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSManagedObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSManagedObjectFactory.ValidateClusterInfo.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSNetIntTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/mscs/MSCSResourceTable.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGDatagramSocket.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGIPCTransportException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGNetAddress.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGNetAddressException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGReceivedDatagram.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGSessionSocketImpl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGSessionSocketImplFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/netipc/TWGUDPSocket.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/rmon/TWGRMONAddressEntryShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/rmon/TWGRMONDevice.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/rmon/TWGRMONDeviceExtension.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/rmon/TWGRMONDeviceObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/rmon/TWGRMONTest.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/ServiceDesk/ServiceDeskConstants.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/ServiceDesk/ServiceDeskUtil.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMP.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMPContext.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMPEntity.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMPPDU.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGMIBItem2.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGRemoteMIB.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGRemoteSNMP.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/iTWGRemoteSNMPResponse.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMPRemoteRequest.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/SNMPRemoteResponse.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGSNMPAddressEntryShadow.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGSNMPDevice.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGSNMPDeviceObjectFactory.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGSNMPException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmp/TWGSNMPInfoBrowserInterface.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/CounterVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/Counter64Vbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/GaugeVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/IntegerVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/IpAddressVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/NsapVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/OidVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/OpaqueVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/StringVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/TimeticksVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/UnsignedVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/NoSuchObjectVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/NoSuchInstanceVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/EndOfMibViewVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/EmptyVbl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/snmputils/VariableBinding.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/SoftwarePackageEditor/PkgFileEntry.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/SoftwarePackageEditor/TWGSwPackage.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/SoftwarePackageEditor/TWGSwPkgMgr.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/SoftwarePackageEditor/TWGSwPkgMgr.PkgTaskListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/util/DataStore.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/util/DataStoreEnumeration.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/util/DataStoreException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/util/Registry.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/util/RegistryException.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFStatusBar.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFStatusField.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFStatusPanel.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFToolbar.AccessibleUFToolBar.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFToolbar.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFToolBarButton.AccessibleUFToolBarButton.html");
        pages.addElement("./javadoc/jav/com/tivoli/uif/controls/UFToolBarButton.html");


        pages.addElement("./javadoc/jav/com/ibm/sysmgt/chassis/ChassisManagedObject.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/AttributeFormatException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/LocateAttributesListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/LocateScopesListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/LocateServicesListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/LocateServiceTypesListener.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/Opaque.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/OpaqueFormatException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/ServiceLocation.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/ServiceLocationException.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/ServiceUrl.html");
        pages.addElement("./javadoc/jav/com/tivoli/twg/engine/slp/UserAgent.html");




























      int endItem = pages.size() - 1;

      // step through each of the pages in the list
      for(int listitem = 0; listitem <= endItem; listitem++)
      {
        try {
            pageToSearch = new URL(myFrame.sdkFind.server + pages.elementAt(listitem));
            System.err.println("SDKFind: Searching " + pageToSearch);
         } catch (MalformedURLException e) {
            System.err.println("SDKFind: Not Searching " + pageToSearch + " - Bad URL.");
         }

        // Grab the contents of a page
         contentsOfPage = getPage(pageToSearch);
         if(!isCaseSensitive) {
            contentsOfPageLC = contentsOfPage.toLowerCase();
         } else {
             contentsOfPageLC = contentsOfPage;
         }

        // We have three separate methods for searching.
        // Only execute the required method.

         String matchContext = null;
         isMatch = false;
         int matchOffset = -1;
        if (myFrame.optionsPanel.isORSearch()) {
            isMatch = matchOR(contentsOfPageLC, subStrings);
        } else if (myFrame.optionsPanel.isANDSearch()) {
            isMatch = matchAND(contentsOfPageLC, subStrings);
        } else {
            matchOffset = matchAsAString(contentsOfPageLC, searchString);
            if (matchOffset > 0 ) {
                isMatch = true;
                matchContext = getContextString(contentsOfPage, matchOffset);
            }
        }



        // If there was a match in the page,
        // add the result to the list of results in resultPanel.
        if (isMatch) {
            String title;
            if ((title = extractTitle(contentsOfPage)) == null) {
                // No valid title was specified in the page:
                // use the page's URL instead.
                myFrame.resultPanel.addResult(pageToSearch.toString(), pageToSearch.toString(),listitem, endItem);
            } else {
                if (matchContext != null) {
                    int padLength = 40 - title.length();
                    if (padLength < 1) padLength = 1;
                    for (int i = 0; i < padLength; i++) {
                        title += " ";
                    }
                    title += matchContext;
                }
                myFrame.resultPanel.addResult(title, pageToSearch.toString(),listitem, endItem);
            }
        } else {
            myFrame.resultPanel.updateProgress(listitem, endItem);
        }

      }   //  end for

        myFrame.searchPanel.searchButton.setEnabled(true);
        myFrame.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }

    protected String getPage (URL dukeOfEarl)
    {
        // Don't use any of the following boolean values.
        // We will use them later for HTML parsing.
        boolean beginTag = false;
        boolean endTag = false;
        boolean insideScript = false;

        InputStream conn = null;
                BufferedReader data = null;
                String line;
                StringBuffer buff = new StringBuffer();

        try {
            conn = dukeOfEarl.openStream();
                        data = new BufferedReader(new InputStreamReader(conn));
            while ((line=data.readLine()) != null) {
                buff.append(line);
            }
        } catch (IOException e) {
            System.out.println("SDKFind: IOError while searching: " + e.getMessage());
            return "";
        }
        return buff.toString();
    }

   // Method to do the AND search. the slowest of all the match methods.
   // For a success, all of the substrings have to be searched for.
    protected boolean matchAND(String content, Vector subStrs)
    {
        Enumeration enumSubstrings = subStrs.elements();
        while(enumSubstrings.hasMoreElements()) {
            String subString = (String) enumSubstrings.nextElement();
            // for each substring
            if (content.indexOf(subString) == -1) {
                // no match.  So return false
                return false;
            }
        }
        // If we fall out of the loop naturally, that means
        // that all the substrings were found in the page.
        return true;
    }

    // Method to do the OR search
    // Medium speed.  The speed can very between
    // matchAND(slowest) and matchAsAString(fastest)
    protected boolean matchOR(String content, Vector subStrs)
    {
        Enumeration enumSubstrings = subStrs.elements();
        while(enumSubstrings.hasMoreElements()) {
            String subString = (String) enumSubstrings.nextElement();
            // For each of the substrings
            if (content.indexOf(subString) != -1) {
                // There is a match!
                return true;
            }
        }
        // We have fallen out of the loop.
        // No matches were found.
        return false;
    }

    // The fastest search method.
    // Note that there is no loop.
    protected int matchAsAString(String content, String subString)
    {
        int index;
        if ((index = content.indexOf(subString)) != -1) {
            return index;
        } else {
            return index;
        }
    }

    public String extractTitle (String content)
    {
        int beginTitleTag, endTitleTag;
        String buff = new String (content.toUpperCase());

        // Find the position of the opening TITLE tag
        // and the closing TITLE tag.
        beginTitleTag = buff.indexOf("<TITLE>");
        endTitleTag = buff.indexOf("</TITLE>");

        // If both were found
        if ((beginTitleTag != -1) && (endTitleTag != -1)) {
            beginTitleTag += 7;     // Move to just after TITLE.
            return content.substring(beginTitleTag,endTitleTag);
        } else {
            return null;
        }
    }

    public String getContextString(String contentsOfPage, int intmatchOffset)
    {
        int startOffset;
        int endOffset;
        // Search backwards looks for a newline, a tag or the beginning of the file;

        startOffset = intmatchOffset;
        while ((startOffset >  intmatchOffset - 60)
                && (startOffset != 0)
               && (contentsOfPage.charAt(startOffset) != '>')
               // && (contentsOfPage.charAt(startOffset) != '\n')
               ) {
           startOffset--;
        }
        // move forward to a word boundary
        while ((contentsOfPage.charAt(startOffset) != ' ')
               && (contentsOfPage.charAt(startOffset) != '\n')
               && (startOffset <  intmatchOffset)
               ) {
            startOffset++;
        }
        if (startOffset < intmatchOffset) startOffset++;

        endOffset = intmatchOffset;
        while ((endOffset <  intmatchOffset + 40)
                && (endOffset < (contentsOfPage.length() -1))
               && (contentsOfPage.charAt(endOffset) != '<')
               // && (contentsOfPage.charAt(endOffset) != '\n')
               ) {
           endOffset++;
        }

        // move backward to  a word break
        while ((contentsOfPage.charAt(endOffset) != ' ')
               && (contentsOfPage.charAt(endOffset) != '\n')
               && (endOffset > intmatchOffset+20)
               ) {
            endOffset--;
        }

        if (startOffset < endOffset) {
            return contentsOfPage.substring(startOffset,endOffset);
        } else {
            return "";
        }
    }
}

