/******************************************************************************
 * Licensed Materials - Property of IBM                                       *
 *                                                                            *
 * (C) Copyright by IBM 2003.  All Rights Reserved.                           *
 *****************************************************************************/

package com.ibm.sysmgt.sdk.tools;

import java.util.ListResourceBundle;

/**
 * This class contains all of the translatable text in the web
 * server managed object sample files.
 *
 * @see java.util.ListResourceBundle
 */
public class SDKCLIResourceBundle_en extends ListResourceBundle
{
  public Object[][] getContents()
  {
    return contents;
  }

  private static final Object[][] contents =
  {
      { "SDKCLITitle", "SDK Command Line Interface" },
      { "SDKCLITasksTitle", "User defined tasks" },
      { "USAGE.1", "This is the IBM Director SDK Command Line Interface.\n" },
      { "USAGE.2", "Listed below are the Command Line Interface commands:\n" },
      { "USAGE.3", "  Help - Shows current help screen\n" },
      { "USAGE.4", "  List - List the bundle commands and syntax\n" },
      { "USAGE.5", "  CreateStaticGroup - Create a group\n" },
      { "USAGE.6", "  DeleteStaticGroup - Delete a group\n" },
      { "USAGE.7", "  CreateSystem - Create a managed system\n" },
      { "USAGE.8", "  DeleteSystem - Delete a managed system\n" },
      { "USAGE.9", "  AddSystemToGroup - Add a managed system to a group\n" },
      { "USAGE.10", "  RemoveSystemFromGroup - Remove a managed system from a group\n" },
      { "USAGE.18", "  ListSystemsInGroup - Lists the managed systems in a group\n" },
      { "USAGE.11", "  AddAttribute - Add an attribute to a managed system\n" },
      { "USAGE.12", "  RemoveAttribute - Remove an attribute from a managed system\n" },
      { "USAGE.19", "  ListAttributes - Lists the attributes in a managed systems\n" },
      { "USAGE.20", "  ListUserDefinedAttributes - Lists the user defined attributes in a user defined managed systems\n" },
      { "USAGE.21", "  ListSystemByUserDefinedAttribute - Lists user defined managed systems by a user defined attribute\n" },
      { "USAGE.22", "  ChanageUserDefinedAttributeValue - Changes a user defined attribute value for a user defined managed system\n" },
//      { "USAGE.13", "  CreateTask - Create a task\n" },
//      { "USAGE.14", "  DeleteTask - Delete a task\n" },
//      { "USAGE.15", "  RunTask - Run a task\n" },
      { "USAGE.16", "  GetStatus - Get the status of a managed system\n" },
      { "USAGE.17", "  SetStatus - Set the status of a managed system\n" },
      { "LIST.1", "Command list\n" },
      { "LIST.2", "  Help\n" },
      { "LIST.3", "  List\n" },
      { "LIST.4", "  CreateStaticGroup <groupname>\n" },
      { "LIST.5", "  DeleteStaticGroup <groupname>\n" },
      { "LIST.6", "  CreateSystem <systemname>\n" },
      { "LIST.7", "  DeleteSystem <systemname>\n" },
      { "LIST.8", "  AddSystemToGroup <groupname> <systemname>\n" },
      { "LIST.9", "  RemoveSystemFromGroup <groupname> <systemname>\n" },
      { "LIST.17", "  ListSystemsInGroup <groupname>\n" },
      { "LIST.10", "  AddAttribute <attribute> <description> <value> <systemname>\n" },
      { "LIST.11", "  RemoveAttribute <attribute> <systemname>\n" },
      { "LIST.18", "  ListAttributes <systemname>\n" },
      { "LIST.19", "  ListUserDefinedAttributes <systemname>\n" },
      { "LIST.20", "  ListSystemByUserDefinedAttribute <attribute>=<value) <systemname>\n" },
      { "LIST.21", "  ChangeUserDefinedAttributeValue <attribute>=<value> <systemname>\n" },
//      { "LIST.12", "  CreateTask <taskname> <path>\n" },
//      { "LIST.13", "  DeleteTask <taskname>\n" },
//      { "LIST.14", "  RunTask <taskname> <systemname>\n" },
      { "LIST.15", "  GetStatus <systemname>\n" },
      { "LIST.16", "  SetStatus <\"online\" | \"offline\" | \"unknown\"> <systemname>\n" },
      { "ERROR.NO_GROUP", "Error: no group name was specified\n" },
      { "ERROR.GROUPCREATION_FAILED", "Error: group creation for {0} failed\n" },
        { "ERROR.DEFAULT", "Error: code =" },
        { "ERROR.SYNTAX", "Error: invalid command syntax\n" },
        { "ERROR.GROUP_INVALID_ID", "Error: group system id invalid\n" },
        { "ERROR.GROUP_NOT_FOUND", "Error: group {0} not found\n" },
        { "ERROR.GROUP_DUPLICATE", "Error: a group named {0} already exists\n" },
        { "ERROR.GROUP_UNDELETEABLE", "Error: group {0} cannot be deleted\n" },
        { "ERROR.GROUPDELETE_FAILED", "Error: deletion failed for group {0}\n" },
        { "ERROR.ADDTOGROUP_FAILED", "Error: the managed system {0} could not be added to group {1}\n" },
        { "ERROR.ALLADDTOGROUP_FAILED", "Error: none of the managed systems could be added to group {0}\n" },
        { "ERROR.REMOVEFROMGROUP_FAILED", "Error: the managed system {0} could not be removed from group {1}, error = {2}\n" },
        { "ERROR.OBJECT_DOESNT_EXIST", "Error: the managed system {0} doesn't exist\n" },
        { "ERROR.OBJECT_NOT_A_MEMBER", "Error: the managed system {0} is not a member of group {1}\n" },
        { "ERROR.NOT_A_USER_DEFINED_MANAGED_SYSTEM", "Error: the managed system {0} is not a user defined managed system\n" },
        { "ERROR.NOT_A_USER_DEFINED_ATTRIBUTE", "Error: {0} is not a user defined attribute\n" },
        { "ERROR.NUMFORMAT", "Error: id format invalid\n" },
        { "ERROR.NO_SYSTEM", "Error: a managed system was not specified\n" },
        { "ERROR.NOT_FOUND", "Error: a managed system named {0} was not found\n" },
        { "ERROR.DUPLICATE", "Error: a managed system named {0} already exists\n" },
        { "ERROR.NOT_DELETE-ABLE", "Error: managed system cannot be deleted\n" },
        { "ERROR.DEL_EXP", "Error: delete action failed\n" },
        { "ERROR.SYS_NOT_FOUND", "Error: managed system not found\n" },
        { "ERROR.SYS_TYPE_INVALID", "Error: action invalid for managed system\n" },
        { "ERROR.GROUP_NOT_STATIC", "Error: group is not static\n" },
        { "ERROR.GROUPGEN_FAILURE", "Error: operation failed for group\n" },
        { "ERROR.SYS_NOT_IN_GROUP", "Error: group does not contain the managed system\n" },
        { "INFO.GROUP_HAS_NO_MEMBERS", "The group {0} does not contain any managed systems\n" },
        { "INFO.GROUP_MEMBERS", "The group {0} contains the following members:\n" },
        { "ERROR.NO_ATTRIBUTE_NAME", "Error: no attribute name was specified\n" },
        { "ERROR.NO_ATTRIBUTE_DESCRIPTION", "Error: no attribute description was specified\n" },
        { "ERROR.NO_ATTRIBUTE_VALUE", "Error: no attribute value was specified\n" },
        { "ERROR.DUPLICATE_ATTRIBUTE", "Error: the attribute {0} is already defined\n" },
        { "ERROR.ATTRIBUTE_DOESNT_EXIST", "Error: the attribute {0} is not defined for this managed system\n" },
        { "INFO.SYSTEM_HAS_NO_ATTRIBUTES", "The managed system {0} has no attributes\n" },
        { "INFO.SYSTEM_HAS_NO_USER_DEFINED_ATTRIBUTES", "The managed system {0} has no user defined attributes\n" },
        { "INFO.ATTRIBUTE_LIST", "The attributes for the managed system named {0} are:\n" },
        { "INFO.USER_DEFINED_ATTRIBUTE_LIST", "The user defined attributes for the managed system named {0} are:\n" },
        { "INFO.USER_DEFINED_SYSTEMS_WITH_ATTRIBUTE_LIST", "The user defined managed systems with the attribute value {0} are:\n" },
        { "INFO.ANOTHER_ATTRIBUTE_LIST", "The attributes for another managed system also named {0} are:\n" },
        { "INFO.ATTRIBUTE_UPDATE_SUCCESSFUL", "The attribute id {0} was set to value {1} for user defined managed system {2}:\n" },
        { "STATUS.OFFLINE", "Offline" },
        { "STATUS.ONLINE", "Online" },
        { "STATUS.UNKNOWN", "Unknown" },
        { "ERROR.STATUS_NOT_FOUND", "Error: the managed system, {0}, was not found\n" },
        { "STATUS.UPDATE_SUCCESSFUL", "{0}:  Update successful\n" },
        { "STATUS.UNDEFINED", "Error: the status {0} is not valid\n" },
        { "STATUS.NOT_SPECIFIED", "Status not specified\n" },
        { "INFO.USER_DEFINED_ATTR_LABEL_1", "User Defined System Subtype" },
        { "INFO.USER_DEFINED_ATTR_DESC_1", "Default" },
        { "addobject.badotherresult.title", "Add Managed System Error" },
        { "addobject.badaddrresult.title", "Invalid Address Error" },
        { "addobject.goodresult.title", "Add Succeeded" },
        { "addobject.badotherresult.msg", "An error occurred while attempting to add the new managed system.\nThe web server has not been added." },
        { "addobject.badaddrresult.msg", "The address provided for the new managed system is not valid." },
        { "addobject.goodresult.msg", "The request to add a new managed system has been completed." },
        { "addobject.duplicateresult.title", "Duplicate Managed System Error" },
        { "addobject.duplicateresult.msg", "Another managed system with the same name already exists.\nThe managed system has not been added." },
  };
}
