/******************************************************************************
 * Licensed Materials - Property of IBM                            *
 *                                                                            *
 * PID (5697-TKT)                                                             *
 *                                                                            *
 * (C) Copyright by IBM 1999-2000.                 *
 * All Rights Reserved.                                                       *
 *****************************************************************************/
package com.BobCo.browserlaunch;

import java.awt.*;
import java.net.*;
import java.io.IOException;

import com.tivoli.twg.console.TWGTaskFrame;
import com.tivoli.twg.engine.*;
import com.tivoli.twg.libs.*;
import com.tivoli.twg.guilibs.*;

/*****************************************************************************
*                         Bob's Software House
*                    A Division of BobCo Enterprises
*****************************************************************************/
/****************************************************************************
* This is an example GUI implementation that will launch a browser with a
* specific URL, so that applications which would like to build browser-based
* GUI's may do so.
* In this example, the task will launch the browser specified in the properties
* file with the Director homepage as the target.  In an actual
* application, the developer would use the information provided by the targeted
* system to determine what URL to bring up, or would query that information
* from his browser-based GUI to determine the target of the task.
*****************************************************************************/
public class SampleBrowserGUI
       extends TWGTaskFrame
{
  /**
  * This is the constructor for creating the task frame that will
  * allow the user to launch a browser gui from the main console.
  */
  public SampleBrowserGUI()
  {
    super(false);
    System.out.println("In the SampleBrowserGUI constructor");
  }


  /**
   * Start the console and display the browser.
   */
  public boolean pInit()
  {
    // Get the object id we are launching the panel for.  Because this is single target,
    // we just need the first (and only) id in the set.
    LongValueSet lvs = getTaskActivator().getMoid();
    long moid = lvs.GetValue( 0 );

    // Now get the object for that ID and get the name of the system.
    TWGConObject obj = TWGConObject.FindObject( moid );
    if ( obj instanceof TWGConManagedObject )
    {
      // Just output the name to show the data is available.  An application could
      // look at any of the data for the object to configure the GUI about to be
      // launched accordingly.
      String moName = ((TWGConManagedObject)obj).getName();
      System.out.println( "Launching browser for system: "+moName );

      // Launch the browser to demonstrate the function.  We have hardcoded it to the
      // Director homepage, but this could be any URL an application wants to use.
      String launchUrl="http://www.pc.ibm.com/ww/eserver/xseries/systems_management/nfdir.html";
      try {
        BrowserLauncher.launchURL( launchUrl );
      } catch (IOException ioe) {
        System.out.println( "Exception launching URL:"+ioe );
      }
    }

    // since launching the browser is all we want to do and we're done, return
    // false so that the task frame doesn't continue building a GUI for us.
    return false;
  }

}
