/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * 09N6996
 *
 * (C) Copyright IBM Corp. 1999, 2003 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

import java.awt.*;
import java.awt.event.*;

public class SearchPanel extends Panel
{
	FindFrame myFrame;
	TextField searchString;
	Button searchButton, clearButton;
	
	// Constructor
	SearchPanel(FindFrame mf) {
		myFrame = mf;
		searchString = new TextField("", 40);
      searchString.setForeground(Color.blue);      
      searchString.setBackground(Color.white);      
      searchString.repaint();                        
		searchButton = new Button("Search");
		//clearButton = new Button("Clear");
		//clearButton.setEnabled(false);

		setLayout(new FlowLayout());
		add(searchString);
		add(searchButton);
		//add(clearButton);
      //  Listen for events.
      searchButton.addActionListener(new SearchListener());
      searchString.addActionListener(new SearchListener());
      repaint();
	}
	
	public void paint(Graphics g) {
		Dimension d = getSize();
		Color bg = getBackground();
		
		g.setColor(bg);
      g.draw3DRect(0,0,d.width-1,d.height-1,true);
		g.draw3DRect(2,2,d.width-5,d.height-5,false);
	}
	
	public Insets getInsets() {
		return new Insets(10,3,0,3);
	}
	
	public Dimension getMinimumSize() {
		Dimension d = new Dimension(400,70);
		return d;
	}
		
	public Dimension getPreferredSize() {
		Dimension d = new Dimension(400,70);
		return d;
	}

	public String getSearchText() {
		return searchString.getText();
	}
	

   // Take action when the search button is pressed.
   class TextListener implements ActionListener {
      public void actionPerformed(ActionEvent evt) {

         System.out.println(" evt="+evt);

			// If no text was entered, don't search.
 /*  		if (getSearchText().length() > 0) {
			// Do the search.
			myFrame.resultPanel.numOfHits = 0;			
			myFrame.sdkFind.pageDB.clear();
			myFrame.resultPanel.clearList();
			myFrame.currentPageNumber = 0;
			FindWords searchForText;
         searchForText = new FindWords(myFrame, myFrame.sdkFind.server, 
                                       getSearchText(), 
                                       myFrame.optionsPanel.isCaseSensitiveSearch());
			}*/
      }
   }


   // Take action when the search button is pressed.
   class SearchListener implements ActionListener {
      public void actionPerformed(ActionEvent evt) {

			// If no text was entered, don't search.
			if (getSearchText().length() > 0) {
			// Do the search.
			myFrame.resultPanel.numOfHits = 0;			
			myFrame.sdkFind.pageDB.clear();
			myFrame.resultPanel.clearList();
			myFrame.currentPageNumber = 0;
			FindWords searchForText;
         searchForText = new FindWords(myFrame, myFrame.sdkFind.server, 
                                       getSearchText(), 
                                       myFrame.optionsPanel.isCaseSensitiveSearch());
			}
      }
   }

   class ClearListener implements ActionListener {
      public void actionPerformed(ActionEvent evt) {
         searchString.setText(null);
         myFrame.resultPanel.clearList();
         clearButton.setEnabled(false);
      }
   }
}

