/*
 * Created on Jan 6, 2004
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.util.Locale;

import com.ibm.sysmgt.sdk.remote.DirectorRemoteSdk;
import com.ibm.sysmgt.sdk.remote.DirectorServer;
import com.ibm.sysmgt.sdk.remote.LoginSession;
import com.ibm.sysmgt.sdk.remote.ServerCommunicationException;
import com.ibm.sysmgt.sdk.remote.UnknownManagerException;

/**
 * @author Dave Wormald
 *
 * 
 */
public class StandaloneTest {

	/**
	 * 
	 */
	public StandaloneTest() {
		super();
	}

	public static void main(String[] args) {
		DirectorServer mgr = null;

		try {
			System.out.println("Getting the manager.");
			mgr = DirectorRemoteSdk.getManager();
		} catch (UnknownManagerException ume) {
			System.out.println("Exception " + ume);
			ume.printStackTrace();
		}

		if (mgr != null) {
			System.out.println("successful.");

		}
		LoginSession s = null;
		try {
			System.out.println("Getting the session.");
			s =
				mgr.createLoginSession(
					"dirconsole",
					"asdf",
					Locale.getDefault());
			if (s == null)
				System.out.println("LoginSession s == null");

		} catch (Exception e) {
			System.out.println("Exception " + e);
			e.printStackTrace();
		}

		if (s != null) {
			System.out.println("successful.");
		}

		System.out.println("Testing for session active.");
		try {
			if (s.isActive()) {
				System.out.println("successful.");
			} else {
				System.out.println("error.");
			}
		} catch (ServerCommunicationException e1) {
			System.out.println("error. ServerCommunicationException" + e1);
			e1.printStackTrace();
		}

		System.out.println("Testing for manager active.");

		if (mgr.isManagerActive(s)) {
			System.out.println("successful.");
		} else {
			System.out.println("error.");
		}

		System.exit(0);

	}
}
