package com.tivoli.twg.mscs;

import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;
import java.beans.*;

import com.tivoli.twg.mscs.*;

/** 
 * Object to represent a resource type in the cluster.  It adds a 
 * "resource dll" field, and the state field is meaningless (null)
 */
public class TWGMSCSClusterResTypeObject extends TWGMSCSClusterObject {
    private String  resdll; /* the dll this resource is sourced from */

    public TWGMSCSClusterResTypeObject(String nname, String nresdll, String ndesc) {
        /* state is meaningless */
        super(nname,null,ndesc);
        resdll=nresdll;
    }

    public void setResDLL(String nresdll) {
        resdll=nresdll;
    }

    public String getResDLL() {
        return resdll;
    }

    public int      getColumns() {
        return 3;
    }

    public String   getColumnHeader(int column) {
        switch (column) {
            case 0:
                return getNlsString("colnameDispName");
            case 1:
                return getNlsString("colnameResDLL");
            case 2:
                return getNlsString("colnameDesc");
            default:
                return getNlsString("stateUnknown");
        }
    }

    public String   getColumnString(int column) {
        switch (column) {
            case 0:
                if (getName()!=null) {
                    return getName();
                }
                break;
            case 1:
                if (getResDLL()!=null) {
                    return getResDLL();
                }
                break;
            case 2:
                if (getDescription()!=null) {
                    return getDescription();
                } else {
                    return new String("");
                }
            default:
                break;
        }
        return getNlsString("stateUnknown");
    }
}

