
package com.tivoli.twg.mscs;

import com.tivoli.twg.engine.*;
import java.util.Properties;

/**
 * Sample engine extension class : defined by the
 * SampExt.TWGExt property file.
 */
public class TWGMSCSExtension extends TWGExtension {
    private static final String NLSBUNDLE = "com.tivoli.twg.mscs.TWGMSCSResources";

    /**
     * Default constructor : usually does nothing, but can access
     * properties loaded from our property file.
     */
    public TWGMSCSExtension() {
        super();
//        System.out.print("!!!!!!!!!!!TWGMSCSExtension(): id=");
//        try {
//          System.out.println(ObjectID());
//        } catch (InvalidObjectIDException ioidx) {
//          System.out.println("<invalid>");
//        }
//        Properties p = getPropertySet();
//        p.list(System.out);     /* Dump properties */
//        System.out.println("!!!!!!!!!!!!!TWGMSCSExtension() done");
    }
    /**
     * First initialization method, intended to allow extensions to register
     * classes.
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitClassRegistration() throws TWGExtensionInitException {
        ;
//        System.out.println("!!!!!TWGMSCSExtension.InitClassRegistration()");
    }
    /**
     * Second initialization method, intended to allow extension to create
     * default instances of classes registered during InitClassRegistration().
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitClassInstances() throws TWGExtensionInitException {
//       System.out.println("!!!!!TWGMSCSExtension.InitClassInstances()");
       boolean err = false;

       if (!TWGTask.isTaskID("Tivoli|MSCSTasks")) {
           try {
              TWGDefaultTask testTask = new TWGDefaultTask("com/tivoli/twg/mscs/TWGMSCSTasks.properties");
           } catch (TWGTaskCreationException e) {
              err = true;
           }
       }

       try {
           /* Initialize modify cluster token                                       */
           if(!TWGPrivToken.isPrivTokenDefined(TWGMSCSConstants.MODIFY_CLUSTER_ACCESS_TOKEN)) {
                  new TWGPrivToken(TWGMSCSConstants.MODIFY_CLUSTER_ACCESS_TOKEN,
                      "privtok." + TWGMSCSConstants.MODIFY_CLUSTER_ACCESS_TOKEN,
                      NLSBUNDLE, false, null);
           }
       } catch (TWGPersistentObjectSaveException posx) {
              throw new TWGExtensionInitException("unable to save privilege tokens");
       }

       if(err == true) {
           throw new TWGExtensionInitException("Error creating MSCS default task");
       }
    }
    /**
     * Final initialization method, intended to allow an extension to do any
     * actions which may have required the other extensions to have completed
     * the previous passes of initialization.
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitCompletion() throws TWGExtensionInitException {
//       System.out.println("!!!!!TWGMSCSExtension.InitCompletion()");
       /*- Do task association stuff here */
       boolean err = false;
       if (err)
         throw new TWGExtensionInitException();
    }
    /**
     * First termination method, intended to allow an extension to begin
     * the process of termination.  The only termination processing which
     * should occur here is that which needs to be done before other
     * extensions have executed TermCompletion() pass.
     *
     * @exception TWGExtensionTermException if an error occurs during the
     * termination method
     */
    public void TermBegin() throws TWGExtensionTermException
    {
//       System.out.println("!!!!!!TWGMSCSExtension.TermBegin()");
       boolean err = false;
       if(err) {
          throw new TWGExtensionTermException();
       }
    }
    /**
     * Final termination method, intended to allow an extension to terminate
     * any processing which may still be active.
     *
     * @exception TWGExtensionTermException if an error occurs during the
     * termination method
     */
    public void TermComplete() throws TWGExtensionTermException {
//       System.out.println("!!!!!TWGMSCSExtension.TermComplete()");
        boolean err = false;
        if(err) {
            throw new TWGExtensionTermException();
        }
    }
}
