
package com.BobCo.rmon;

import com.tivoli.twg.engine.*;
import com.tivoli.twg.snmp.*;
import java.util.Properties;
import com.tivoli.twg.engine.TWGImageSet;

/**
 * Sample engine extension class : defined by the
 * SampExt.TWGExt property file.
 */
public class TWGRMONDeviceExtension extends TWGExtension {
    /**
     * Default constructor : usually does nothing, but can access
     * properties loaded from our property file.
     */
    public TWGRMONDeviceExtension() {
        super();
    }
    /**
     * First initialization method, intended to allow extensions to register
     * classes.
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitClassRegistration() throws TWGExtensionInitException {
        String c = "";
        // now register all of our persistent object classes here
        try {
            c = "com.tivoli.twg.rmon.TWGRMONDevice";
            RegisterClass(c);
            c = "com.tivoli.twg.rmon.TWGRMONDeviceObjectFactory";
            RegisterClass(c);
        } catch (ClassNotFoundException cnfx) {
            throw new TWGExtensionInitException("Class '" + c + "' not found: " + cnfx);
        }

    }
    /**
     * Second initialization method, intended to allow extension to create
     * default instances of classes registered during InitClassRegistration().
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitClassInstances() throws TWGExtensionInitException {

        /* Register any image sets                                          */
        try {
            TWGImageSet is1 = TWGImageSet.FindImageSet(TWGRMONDeviceObjectFactory.IMAGE_SET);
            TWGImageSet Temp2 = TWGImageSet.FindImageSet(TWGRMONDeviceObjectFactory.FILTER_SET);
        } catch (TWGPersistentObjectSaveException posx) {
            throw new TWGExtensionInitException("error registering ImageSet");
        }

    }
    /**
     * Final initialization method, intended to allow an extension to do any
     * actions which may have required the other extensions to have completed
     * the previous passes of initialization.
     *
     * @exception TWGExtensionInitException if a fatal error occurs during
     * the initialization method
     */
    public void InitCompletion() throws TWGExtensionInitException {
    }
    /**
     * First termination method, intended to allow an extension to begin
     * the process of termination.  The only termination processing which
     * should occur here is that which needs to be done before other
     * extensions have executed TermCompletion() pass.
     *
     * @exception TWGExtensionTermException if an error occurs during the
     * termination method
     */
    public void TermBegin() throws TWGExtensionTermException {
        boolean err = false;
        if(err) {
            throw new TWGExtensionTermException();
        }
    }
    /**
     * Final termination method, intended to allow an extension to terminate
     * any processing which may still be active.
     *
     * @exception TWGExtensionTermException if an error occurs during the
     * termination method
     */
    public void TermComplete() throws TWGExtensionTermException {
        boolean err = false;
        if(err) {
            throw new TWGExtensionTermException();
        }
    }
}
