/*
 * Created on Jan 19, 2004
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.io.File;
import java.util.Locale;

import com.ibm.sysmgt.sdk.remote.*;
import com.tivoli.twg.libs.TWGEnvironment;

/**
 * @author Dave Wormald
 *
 * 
 */
public class TestDirectorServerWithMain {

	/**
	 * 
	 */
	public TestDirectorServerWithMain() {
		super();
	}
	protected static DirectorServer mgr = null;
	protected static LoginSession s;

	public static void main(String[] args) {
		System.out.println("hello.");

		System.setProperty(
			TWGEnvironment.PROP_DIR_DATA,
			"c:"
				+ File.separator
				+ "Program Files"
				+ File.separator
				+ "IBM"
				+ File.separator
				+ "director"
				+ File.separator
				+ "data");

		String FILENAME_LOCAL_IPC_KEY =
			TWGEnvironment.getDataDirectory() + File.separator + "localipc.key";

		System.out.println("FILENAME_LOCAL_IPC_KEY=" + FILENAME_LOCAL_IPC_KEY);

		try {
			mgr = DirectorRemoteSdk.getManager("localhost");
		} catch (UnknownManagerException ume) {
			System.out.println("UnknownManagerException=" + ume);
			ume.printStackTrace();
		}

		try {
			s =
				mgr.createLoginSession(
					"dirconsole",
					"asdf",
					Locale.getDefault());

			s.printDebugMessages();

			if ((s == null))
				System.out.println("Session is bad");
			else
				System.out.println("Session is good");

			if (!s.isActive())
				System.out.println("Session is inactive");
			else
				System.out.println("Session is active");

			if (!mgr.isManagerActive(s))
				System.out.println("manager is inactive");
			else
				System.out.println("manager is active");

		} catch (Exception e) {
			System.out.println("Exception " + e);
			e.printStackTrace();
		}

		System.exit(5);

	}
}
