/*
 * Created on Nov 10, 2003
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.util.List;
import java.util.Locale;
import java.util.Map;

import junit.framework.Assert;
import junit.framework.TestCase;

import com.ibm.sysmgt.sdk.remote.Attribute;
import com.ibm.sysmgt.sdk.remote.DirectorEvent;
import com.ibm.sysmgt.sdk.remote.DirectorEventLog;
import com.ibm.sysmgt.sdk.remote.DirectorRemoteSdk;
import com.ibm.sysmgt.sdk.remote.DirectorServer;
import com.ibm.sysmgt.sdk.remote.Log;
import com.ibm.sysmgt.sdk.remote.LoginSession;
import com.ibm.sysmgt.sdk.remote.ManagedGroup;
import com.ibm.sysmgt.sdk.remote.ManagedSystem;
import com.ibm.sysmgt.sdk.remote.Task;
import com.ibm.sysmgt.sdk.remote.UnknownManagerException;
import com.tivoli.twg.libs.DataValue;
import com.tivoli.twg.libs.TWGByteArray;
import com.tivoli.twg.libs.TWGEnvironment;
import com.tivoli.twg.libs.TWGLong;

/**
 * @author Dave Wormald
 *
 */
public class TestFindByUUID extends SetupToUseDirectorServer {

	public void testGetByUUID() {
		try {

			if (s == null)
				fail();

			List systemlist = ManagedSystem.getAllSystems(s);
			if (systemlist.size() == 0)
				fail();

			boolean foundSytemWithUUID = false;
			DataValue dvUuid = null;

			int i = 0;
			while (!foundSytemWithUUID && (i < systemlist.size())) {
				ManagedSystem system = (ManagedSystem) systemlist.get(i);
				Map attributeList = system.getSystemAttributes(s);
				println(
					"Attributes for system '"
						+ system.getLabel()
						+ "': "
						+ attributeList);

				Object obj = attributeList.get("MO.UUID");
				println("MO.UUID=" + obj);
				Attribute uidAttrib = (Attribute) obj;
				dvUuid = (DataValue) uidAttrib.getValue();

				if (dvUuid != null) {
					println("Found a UUID Datavalue ");
					println(
						"UID Datavalue class = "
							+ dvUuid.getClass().getName()
							+ " Found a UUID Datavalue value="
							+ dvUuid.toString());
					foundSytemWithUUID = true;

				}

				i++;
			}

			Assert.assertTrue("no systems with UUID", dvUuid != null);

			String uuid = dvUuid.toString();
			TWGByteArray ba = null;
			if (dvUuid.getDataValueType() == DataValue.BYTE_ARRAY_TYPE) {
				ba = (TWGByteArray) dvUuid;
			} else {
				fail("dvUuid is not a byte array");
			}

			List foundList = ManagedSystem.getSystemsByUUID(s, ba);
			Assert.assertTrue(foundList.size() > 0);

			println("Found by UID: " + foundList);
			ManagedSystem foundSystem = (ManagedSystem) foundList.get(0);

		} catch (Exception e) {
			e.printStackTrace();
			fail(e.getMessage());
		}

	}

	public void testGetByUUID2() {
		try {

			if (s == null)
				fail();

			List systemlist = ManagedSystem.getAllSystems(s);
			if (systemlist.size() == 0)
				fail();

			boolean foundSytemWithUUID = false;
			DataValue dvUuid = null;

			int i = 0;
			while (!foundSytemWithUUID && (i < systemlist.size())) {
				ManagedSystem system = (ManagedSystem) systemlist.get(i);
				Object obj = system.getAttribute(s, "MO.UUID");

				println("MO.UUID=" + obj);
				Attribute uidAttrib = (Attribute) obj;
				dvUuid = (DataValue) uidAttrib.getValue();

				if (dvUuid != null) {
					println("Found a UUID Datavalue ");
					println(
						"UID Datavalue class = "
							+ dvUuid.getClass().getName()
							+ " Found a UUID Datavalue value="
							+ dvUuid.toString());
					foundSytemWithUUID = true;

				}

				i++;
			}

			Assert.assertTrue("no systems with UUID", dvUuid != null);

			String uuid = dvUuid.toString();
			TWGByteArray ba = null;
			if (dvUuid.getDataValueType() == DataValue.BYTE_ARRAY_TYPE) {
				ba = (TWGByteArray) dvUuid;
			} else {
				fail("dvUuid is not a byte array");
			}

			List foundList = ManagedSystem.getSystemsByUUID(s, ba);
			Assert.assertTrue(foundList.size() > 0);

			println("Found by UID: " + foundList);
			ManagedSystem foundSystem = (ManagedSystem) foundList.get(0);

		} catch (Exception e) {
			e.printStackTrace();
			fail(e.getMessage());
		}

	}

	/**
	 * 
	 */
	public TestFindByUUID() {
		super();

	}

	/**
	 * @param arg0
	 */
	public TestFindByUUID(String arg0) {
		super(arg0);

	}

}
