/* file:  monitors\com\apidll.hpp */
// Licensed Materials - Property of IBM
//
// OCO Source Materials
// 
// 09N6996
//
// (C) Copyright IBM Corp. 1999, 2002 All Rights Reserved
//
// The source code for this program is not published or other-
// wise divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
#ifndef __APIDLL_HPP_INCLUDED__
#define __APIDLL_HPP_INCLUDED__
#include "sys_inc.hpp"        // include required system files
#include "monapi.h"
#include "dll.hpp"
#include "string.hpp"

//====================
// TWGMonAPIDLL class
//====================
class TWGMonAPIDLL : public DynamicLinkLibrary
{
   private:
      long                 (APIENTRY  *DllInit) ( );
      long                 (APIENTRY  *DllTerm) ( );
      AttributeNodeList MONFAR *(APIENTRY  *DllGetNodeList) (AttributePath MONFAR *);
      long                 (APIENTRY  *DllFreeNodeList) (AttributeNodeList MONFAR *);
      MonHandle MONFAR    *(APIENTRY  *DllGetHandle) (AttributePath MONFAR *);
      long                 (APIENTRY  *DllReleaseHandle) (MonHandle MONFAR *);
      MonData MONFAR      *(APIENTRY  *DllGetData) (ULONG);
      long                 (APIENTRY  *DllFreeData) (MonData MONFAR *);
      MonMetaData MONFAR  *(APIENTRY  *DllGetMetaData) (ULONG);
      long                 (APIENTRY  *DllFreeMetaData) (MonMetaData MONFAR *);
      BOOL                 (APIENTRY  *DllLogDebug) (char MONFAR *);

      long                 lInit;

   public:
      TWGMonAPIDLL(char *);
      ~TWGMonAPIDLL();

      long                 init();
      long                 term();
      BOOL                 isOK();
      AttributeNodeList MONFAR *getNodeList( AttributePath MONFAR *);
      long                 freeNodeList( AttributeNodeList MONFAR *);
      MonHandle MONFAR    *getHandle( AttributePath MONFAR *);
      long                 releaseHandle( MonHandle MONFAR *);
      MonData MONFAR      *getData( ULONG);
      long                 freeData( MonData MONFAR *);
      MonMetaData MONFAR  *getMetaData( ULONG);
      long                 freeMetaData( MonMetaData MONFAR *);
      BOOL                 logDebug( char MONFAR *);
};

#endif
